Attribute VB_Name = "basGroup"
Option Explicit

Public Enum eiGroupDisp
    eiGDispNew
    eiGDispEdit
End Enum

Public Const clGDispNew As Integer = 1
Public Const clGDispEdit    As Integer = 1

Public Const ciMaxGroup As Integer = 30
Private Type mtGroups
    llUserNum           As Long         ' o^[U[
    llGroupId           As Long         ' O[vhcirbgj
    lsGroupName         As String       ' O[v
End Type

Private mlGroupIndex    As Long         ' Ώۂ̃CfbNXԍ
Private mlUseGroup      As Long         ' gp̃O[vhcirbgj
Private mtGroupInfo(ciMaxGroup) As mtGroups ' O[v̏

Public Function brgGetGroupInfo(ByRef plUserNum As Long, ByRef plGroupId As Long, ByRef psGroupName As String, ByVal plGroupIndex As Long) As Long
'---------------------------------------------------------------------------
'    : brGetGroupInfo()
' @@@\ : O[v̎擾
' @@ : (O) plUserNum      o^[U[
'          : (O) plGroupId      O[vhc
'          : (O) psGroupName    O[v
'          : (I) plGroupIndex   CfbNXi -1 ̂Ƃ͏Ώۂ̏߂j
'   l : CfbNX
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    Dim llIndex         As Long         ' CfbNXԍ

    If plGroupIndex = -1 Then
        llIndex = mlGroupIndex
    Else
        llIndex = plGroupIndex
    End If
    plUserNum = mtGroupInfo(llIndex).llUserNum
    plGroupId = mtGroupInfo(llIndex).llGroupId
    psGroupName = mtGroupInfo(llIndex).lsGroupName

    brgGetGroupInfo = llIndex
End Function

Public Sub brgPutGroupInfo(ByVal psGroupName As String, ByVal plIndex As Long, Optional ByVal plUserNum As Long, Optional ByVal plGroupId As Long)
'---------------------------------------------------------------------------
'    : brgPutGroupInfo()
' @@@\ : O[v̐ݒ
' @@ : (I) psGroupName    O[v
'          : (I) plIndex        O[vo^CfbNXi -1 ̂Ƃ͐VKj
'          : (I) plUserNum      o^[U[
'          : (I) plGroupId      O[vhc
'   l : Ȃ
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long         ' [vJE^
    Dim llBit           As Long         ' rbgl

    llBit = 1
    If plIndex = -1 Then ' VK
        For llLoopCnt = 1 To ciMaxGroup
            If (llBit And mlUseGroup) = 0 Then
                mtGroupInfo(llLoopCnt - 1).llUserNum = 0
                mtGroupInfo(llLoopCnt - 1).llGroupId = llBit
                mtGroupInfo(llLoopCnt - 1).lsGroupName = psGroupName
                brgUseGroup = llBit
                mlGroupIndex = llLoopCnt - 1
                Exit For
            End If
            llBit = llBit * 2
        Next llLoopCnt
    Else ' ύX
        mtGroupInfo(plIndex).llUserNum = plUserNum
        mtGroupInfo(plIndex).llGroupId = plGroupId
        mtGroupInfo(plIndex).lsGroupName = psGroupName
        mlGroupIndex = plIndex
    End If
End Sub

Public Function brgGetNewGroupId() As Long
'---------------------------------------------------------------------------
'    : brgGetNewGroupId()
' @@@\ : VO[vhc̎擾
' @@ : Ȃ
'   l : VO[vhciOhcȂj
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long         ' [vJE^
    Dim llBit           As Long         ' rbgl

    llBit = 1
    brgGetNewGroupId = 0
    For llLoopCnt = 1 To ciMaxGroup
        If (llBit And mlUseGroup) = 0 Then
            brgGetNewGroupId = llBit
            Exit For
        End If
        llBit = llBit * 2
    Next llLoopCnt
End Function

Public Property Get brgUseGroup() As Long
'---------------------------------------------------------------------------
'    : brgUseGroup()
' @@@\ : gp̃O[vhc̎擾
' @@ : Ȃ
'   l : gp̃O[vhc
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    brgUseGroup = mlUseGroup
End Property

Public Property Let brgUseGroup(ByVal psUseGroup As Long)
'---------------------------------------------------------------------------
'    : brgUseGroup()
' @@@\ : gp̃O[vhc̐ݒ
' @@ : (I) psUseGroup     gp̃O[vhc
'   l : Ȃ
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    mlUseGroup = mlUseGroup + psUseGroup
End Property

Public Property Get brgGroupIndex() As Long
'---------------------------------------------------------------------------
'    : brgGroupIndex()
' @@@\ : ΏۃO[vԍ̎擾
' @@ : Ȃ
'   l : Ώۂ̃O[vԍ
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    brgGroupIndex = mlGroupIndex
End Property

Public Property Let brgGroupIndex(ByVal plGroupIndex As Long)
'---------------------------------------------------------------------------
'    : brgGroupIndex()
' @@@\ : ΏۃO[vԍ̐ݒ
' @@ : (I) plGroupIndex   Ώۂ̃O[vԍ
'   l : Ȃ
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    mlGroupIndex = plGroupIndex
End Property

Public Sub brgInitGroupInfo()
'---------------------------------------------------------------------------
'    : brgInitGroupInfo()
' @@@\ : O[v̏
' @@ : Ȃ
'   l : Ȃ
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    Dim ltWorkGInfo     As mtGroups     ' O[v̏
    Dim llLoopCnt       As Long         ' [vJE^

    mlUseGroup = 0
    For llLoopCnt = 0 To ciMaxGroup
        mtGroupInfo(llLoopCnt) = ltWorkGInfo
    Next llLoopCnt
End Sub

Public Function brgReadGroupInfo(ByVal piFileNo As Integer) As Boolean
'---------------------------------------------------------------------------
'    : brgReadGroupInfo()
' @@@\ : O[v̓ǂݍ
' @@ : (I) piFileNo       t@Cԍ
'   l : True= I, False= ُI
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    On Error GoTo brgReadGroupInfo_Error

    Get #piFileNo, , mlUseGroup
    Get #piFileNo, , mtGroupInfo

    brgReadGroupInfo = True
    Exit Function

brgReadGroupInfo_Error:
    brgReadGroupInfo = False
End Function

Public Function brgWriteGroupInfo(ByVal piFileNo As Integer) As Boolean
'---------------------------------------------------------------------------
'    : brgWriteGroupInfo()
' @@@\ : O[v̏
' @@ : (I) piFileNo       t@Cԍ
'   l : True= I, False= ُI
' @@ : 2000/11/25
'---------------------------------------------------------------------------
    On Error GoTo brgWriteGroupInfo_Error

    Put #piFileNo, , mlUseGroup
    Put #piFileNo, , mtGroupInfo

    brgWriteGroupInfo = True
    Exit Function

brgWriteGroupInfo_Error:
    brgWriteGroupInfo = False
End Function
