Attribute VB_Name = "basUserInfo"
Option Explicit

Private Const csDatVersion  As String = "00002.00"

Public Sub brbReadUserInfo(ByRef pcUserInfo As Collection)
'---------------------------------------------------------------------------
'    : brbReadUserInfo()
' @@@\ : [U[t@C̓ǂݍ
' @@ : (O) pcUserInfo     [U[
'   l : Ȃ
' @@ : 1999/11/25
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long             ' [vJE^
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsFileName      As String           ' t@C
    Dim lsDatVer        As String * 8       ' o[Wԍ
    Dim lvValues        As Variant          ' ݒl
    Dim llDataCnt       As Long             ' f[^
    Dim lcUserName      As cUserName        ' [U[
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo ptReadDatFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsFileName = lsAppPath & App.ProductName & ".dat"
    Else
        lsFileName = lsAppPath & "\" & App.ProductName & ".dat"
    End If
    liFileNo = FreeFile

    For llLoopCnt = 1 To pcUserInfo.Count
        Call pcUserInfo.Remove(llLoopCnt)
    Next llLoopCnt

    Open lsFileName For Binary Access Read As liFileNo
    Get #liFileNo, , lsDatVer
    If lsDatVer = "00001.00" Then
        brgInitGroupInfo
        Get #liFileNo, , llDataCnt
        For llLoopCnt = 1 To llDataCnt
            Set lcUserName = New cUserName
            Get #liFileNo, , lvValues
            lcUserName.brParamValue(csUserName) = lvValues
            Get #liFileNo, , lvValues
            lcUserName.brParamValue(csBirthDay) = lvValues
            Get #liFileNo, , lvValues
            lcUserName.brParamValue(csSelected) = lvValues
            Call pcUserInfo.Add(lcUserName)
        Next llLoopCnt
    ElseIf lsDatVer = "00002.00" Then
        brgReadGroupInfo liFileNo
        Get #liFileNo, , llDataCnt
        For llLoopCnt = 1 To llDataCnt
            Set lcUserName = New cUserName
            Get #liFileNo, , lvValues
            lcUserName.brParamValue(csUserName) = lvValues
            Get #liFileNo, , lvValues
            lcUserName.brParamValue(csBirthDay) = lvValues
            Get #liFileNo, , lvValues
            lcUserName.brParamValue(csSelected) = lvValues
            Get #liFileNo, , lvValues
            lcUserName.brParamValue(csMyGroupID) = lvValues
            Call pcUserInfo.Add(lcUserName)
        Next llLoopCnt
    Else
        MsgBox "f[^t@C̓ǂݍ݂Ɏs܂B" & vbCrLf & lsFileName, vbCritical, "G["
    End If
    Close liFileNo

    Exit Sub

ptReadDatFile_Error:
    Close liFileNo
End Sub

Public Sub brbWriteUserInfo(ByVal pcUserInfo As Collection)
'---------------------------------------------------------------------------
'    : brbWriteUserInfo()
' @@@\ : [U[t@C̏
' @@ : (I) pcUserInfo     [U[
'   l : Ȃ
' @@ : 1999/11/25
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long             ' [vJE^
    Dim liRetCode       As Integer          ' ߂l
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsFileName      As String           ' t@C
    Dim lcUserName      As cUserName        ' [U[
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo brbWriteUserInfo_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsFileName = lsAppPath & App.ProductName & ".dat"
    Else
        lsFileName = lsAppPath & "\" & App.ProductName & ".dat"
    End If
    liFileNo = FreeFile

    Open lsFileName For Binary Access Write As liFileNo
    Put #liFileNo, , csDatVersion
    brgWriteGroupInfo liFileNo
    Put #liFileNo, , pcUserInfo.Count
    For llLoopCnt = 1 To pcUserInfo.Count
        Set lcUserName = pcUserInfo.Item(llLoopCnt)
        Put #liFileNo, , lcUserName.brParamValue(csUserName)
        Put #liFileNo, , lcUserName.brParamValue(csBirthDay)
        Put #liFileNo, , lcUserName.brParamValue(csSelected)
        Put #liFileNo, , lcUserName.brParamValue(csMyGroupID)
    Next llLoopCnt
    Close liFileNo

    Exit Sub

brbWriteUserInfo_Error:
    liRetCode = MsgBox("[U[t@C݂̏Ɏs܂B" & vbCrLf & lsFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close liFileNo
End Sub

Public Sub brbExportUserInfo(ByVal pcUserInfo As Collection, ByVal psFileName As String)
'---------------------------------------------------------------------------
'    : brbExportUserInfo()
' @@@\ : [U[t@C̃GNX|[g
' @@ : (I) pcUserInfo     [U[
'          : (I) psFileName     t@C
'   l : Ȃ
' @@ : 2001/12/15
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long             ' [vJE^
    Dim liRetCode       As Integer          ' ߂l
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsDelimChar     As String           ' ؂蕶
    Dim lcUserName      As cUserName        ' [U[
    Dim liPosition      As Integer          ' o͏

    On Error GoTo brbExportUserInfo_Error

    liFileNo = FreeFile
    lsDelimChar = basParam.brParamValue(csDelimChar)
    liPosition = basParam.brParamValue(csPosition)
    Open psFileName For Output Access Write As liFileNo
    For llLoopCnt = 1 To pcUserInfo.Count
        Set lcUserName = pcUserInfo.Item(llLoopCnt)
        If liPosition = 1 Then
            Print #liFileNo, brbChangeString2Csv(lcUserName.brParamValue(csUserName), lsDelimChar) & lsDelimChar & Format(lcUserName.brParamValue(csBirthDay), "yyyy/m/d")
        Else
            Print #liFileNo, Format(lcUserName.brParamValue(csBirthDay), "yyyy/m/d") & lsDelimChar & brbChangeString2Csv(lcUserName.brParamValue(csUserName), lsDelimChar)
        End If
    Next llLoopCnt
    Close liFileNo

    Exit Sub

brbExportUserInfo_Error:
    liRetCode = MsgBox("t@C݂̏Ɏs܂B" & vbCrLf & psFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close liFileNo
End Sub

Public Function brbImportUserInfo(ByRef pcUserInfo As Collection, ByVal psFileName As String) As Boolean
'---------------------------------------------------------------------------
'    : brbImportUserInfo()
' @@@\ : [U[t@C̃C|[g
' @@ : (I/O) pcUserInfo   [U[
'          : ( I ) psFileName   t@C
'   l : Ȃ
' @@ : 2001/12/15
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long             ' [vJE^
    Dim liRetCode       As Integer          ' ߂l
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim llLineNum       As Long             ' sԍ
    Dim lsLine          As String           ' ǂݍݕ
    Dim liSepPos        As Integer          ' Zp[^ʒu
    Dim lcUserName      As cUserName        ' [U[
    Dim lsDelimChar     As String           ' ؂蕶
    Dim liPosition      As Integer          ' o͏
    Dim lsUserName      As String           ' OiƗpj
    Dim ldBirthDay      As Date             ' a
    Dim lbErrFlag       As Boolean          ' G[tO
    Dim lsErrMsg        As String           ' G[bZ[W

    On Error GoTo brbImportUserInfo_Error

    liFileNo = FreeFile
    lsDelimChar = basParam.brParamValue(csDelimChar)
    liPosition = basParam.brParamValue(csPosition)
    Open psFileName For Input Access Read As liFileNo
    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        llLineNum = llLineNum + 1
        lsLine = LTrim(lsLine)
        If Left(lsLine, 1) = """" Then
            liSepPos = InStr(lsLine, """" & lsDelimChar)
            If liSepPos = 0 Then
                liSepPos = InStr(lsLine, lsDelimChar)
            Else
                liSepPos = liSepPos + 1
            End If
        Else
            liSepPos = InStr(lsLine, lsDelimChar)
        End If

        If liSepPos > 0 Then
            lbErrFlag = False
            If liPosition = 1 Then
                lsUserName = brbChangeCsv2String(Left$(lsLine, liSepPos - 1))
                ldBirthDay = Mid$(lsLine, liSepPos + 1)
            Else
                lsUserName = brbChangeCsv2String(Mid$(lsLine, liSepPos + 1))
                ldBirthDay = Left$(lsLine, liSepPos - 1)
            End If
            If lbErrFlag = False Then
                If lsUserName <> "" Then
                    Set lcUserName = New cUserName
                    lcUserName.brParamValue(csUserName) = lsUserName
                    lcUserName.brParamValue(csBirthDay) = ldBirthDay
                    Call pcUserInfo.Add(lcUserName)
                End If
            End If
        End If
    Loop
    Close liFileNo

    brbImportUserInfo = True
    Exit Function

brbImportUserInfo_Error:
    If llLineNum > 0 Then
        lsErrMsg = "t@C̓ǂݍ݂Ɏs܂Bi" & llLineNum & "sځj" & vbCrLf & psFileName & vbCrLf & "ǂݍ݂p܂H"
        liRetCode = MsgBox(lsErrMsg, vbCritical Or vbYesNo, "G[")
        If liRetCode = vbYes Then
            lbErrFlag = True
            Resume Next
        End If
    Else
        lsErrMsg = "t@C̓ǂݍ݂Ɏs܂B" & vbCrLf & psFileName
        liRetCode = MsgBox(lsErrMsg, vbCritical Or vbRetryCancel, "G[")
        If liRetCode = vbRetry Then
            Resume
        End If
    End If
    brbImportUserInfo = False
    Close liFileNo
End Function

Public Function brbChangeString2Csv(ByVal psString As String, ByVal psDelimChar As String) As String
'---------------------------------------------------------------------------
'    : brbChangeString2Csv()
' @@@\ : bru`ɃtH[}bg
' @@ : (I) psString       ϊ镶
'   l : ϊ̕
' @@ : 2001/12/15
'---------------------------------------------------------------------------
    Dim liLoopCnt           As Integer      ' [vJE^
    Dim lsChar              As String * 1   ' 擾iPj
    Dim lsAfterString       As String       ' ϊ㕶
    Dim lbChangeFlag        As Boolean      ' ϊtO

    lbChangeFlag = False

    For liLoopCnt = 1 To Len(psString)
        lsChar = Mid$(psString, liLoopCnt, 1)
        If lsChar = """" Then
            lsAfterString = lsAfterString & lsChar & lsChar
            lbChangeFlag = True
        Else
            If lsChar = psDelimChar Then
                lbChangeFlag = True
            End If
            lsAfterString = lsAfterString & lsChar
        End If
    Next liLoopCnt

    If lbChangeFlag = False Then
        brbChangeString2Csv = psString
    Else
        brbChangeString2Csv = """" & lsAfterString & """"
    End If
End Function

Private Function brbChangeCsv2String(ByVal psString As String) As String
'---------------------------------------------------------------------------
'    : brbChangeCsv2String()
' @@@\ : bru`̃tH[}bg𕶎ɕϊ
' @@ : (I) psString       ϊ镶
'   l : ϊ̕
' @@ : 2001/12/15
'---------------------------------------------------------------------------
    Dim liLoopCnt           As Integer      ' [vJE^
    Dim lsChar              As String * 1   ' 擾iPj
    Dim lsAfterString       As String       ' ϊ㕶
    Dim lbChangeFlag        As Boolean      ' ϊtO
    Dim lbDouble            As Boolean      ' " tO

    lbChangeFlag = False

    If Left(psString, 1) = """" And Right(psString, 1) = """" Then
        For liLoopCnt = 2 To Len(psString) - 1
            lsChar = Mid$(psString, liLoopCnt, 1)
            If lsChar = """" Then
                If lbDouble <> False Then
                    lbDouble = False
                    lsAfterString = lsAfterString & lsChar
                Else
                    lbDouble = True
                End If
            Else
                If lbDouble <> False Then
                    lsAfterString = lsAfterString & """" & lsChar
                Else
                    lsAfterString = lsAfterString & lsChar
                End If
                lbDouble = False
            End If
        Next liLoopCnt
    Else
        lsAfterString = psString
    End If

    brbChangeCsv2String = lsAfterString
End Function
